var nativeArray = function(){ return this.Array }()
  , nativeArrayProto = nativeArray.prototype
  , arrayProto = Array.prototype

function Array() {
  var self = this instanceof Array ? this : new Array

  nativeArrayProto.push.apply(self, nativeArray.apply(null, arguments))

  return self
}

arrayProto.length = 0

arrayProto.forEach = nativeArrayProto.forEach || function(fn, self) {
  // make work w/ functions
  for (var i = 0, l = this.length; i < l; i++) {
    fn.call(self, this[i], i, this)
  }
}

arrayProto.observe = function observe(cb) {
  var index, remaining, observed

  if (typeof this == "function") {
    return this(function(err, self) {
      err ? cb(err) : observe.call(self, cb)
    })
  }

  index = remaining = this.length
  observed = []

  if (index > 0) while (index--) !function(index) {
    !function set(err, value) {
      if (typeof value == "function") return value(set)

      if (remaining && !(index in observed)) {
        --remaining || (remaining = false)
      }

      observed[index] = err || value
      remaining || cb(null, observed)
    }(null, this[index])
  }.call(this, index)

  else if (index == 0) return cb(null, observed)

  else return cb(new Error("Invalid length: " + index))
}

module.exports = Array