var Array = require("./Array")
  , ArrayPrototype = Array.prototype
  , observe = ArrayPrototype.observe

  , operations = Array(
    // unary
      "!x", "~x", "+x", "-x", "typeof x", "void x",

    // binary
      "x * y", "x / y", "x % y", "x + y", "x - y", "x << y",
      "x >> y", "x >>> y", "x < y", "x <= y", "x > y", "x >= y",
      "x == y", "x != y", "x === y", "x !== y", "x & y",
      "x ^ y", "x | y", "x && y", "x || y", "x, y", "x[y]",
      "x in y", "x instanceof y", "x(y)",

    // ternary
      "x ? y : z"
  )

operations.forEach(function(text) {
  var args = text.match(/\b[xyz]/g)
    , operator = text.replace(/\b[xyz]| /g, "")
    , arity = args.length

    , fn = Function(args, "return " + text)

  exports[operator] = function() {
    var i = arity
      , args = arguments

    while (i--) if (typeof arguments[i] == "function") {
      return function(cb) {
        observe.call(args, function(err, args) {
          if (err) return cb(err, args)

          try { return cb(null, fn.apply(null, args)) }
          catch (e) { return cb(e, args) }
        })
      }
    }

    return fn.apply(null, args)
  }
})

exports["new"] = function _new(ctor, args) {
  var length = args ? -~args.length : 0
    , fn = _new[length]

  fn || (fn = _new[length] = Function(
    "ctor", "args", "i",
    "return new ctor(" +
      Array(length).join(", args[i++]").slice(1) +
    ")"
  ))

  return fn(ctor, args, 0)
}